# Configuration parameters
DEFAULT_HTTP_PORT  := 8081

DATE := $(shell date +"%Y_%m_%d_%H_%M_%S")
CONFIG_TMP_FILE := $(CONFIGDIR)/config.json.tmp
CONFIG_OLD_FILE := $(CONFIGDIR)/config_old_$(DATE).json
CONFIG_FILE := $(CONFIGDIR)/config.json
DEAFULT_CONFIG := $(REPO_AFAP)/test/configs/test_config_1.tmpl.json

.PHONY: $(CONFIGDIR)
$(CONFIGDIR): ; -@mkdir -p $@

.PHONY: $(CONFIG_TMP_FILE)
$(CONFIG_TMP_FILE): | $(CONFIGDIR)
	@cp $(DEAFULT_CONFIG) $@

FIXME := "FIXME"
EMPTY := ""

.PHONY: generateUvrConfigFile
generateUvrConfigFile: $(CONFIG_TMP_FILE) $(EDIT_JSON)
	@$(EDIT_JSON) $< $< replace "/uvr/id" "\"$(FIXME)\""
	@$(EDIT_JSON) $< $< replace "/vfgw/http/privateKeyPath" "\"$(EMPTY)\""
# modify HTTP ports
	@$(EDIT_JSON) $< $< replace "/vfgw/http/remote port" "\"$(DEFAULT_HTTP_PORT)\""
	@$(EDIT_JSON) $< $< replace "/vfgw/http/local port" "\"$(DEFAULT_HTTP_PORT)\""
# remove "another_pmjob"
	@$(EDIT_JSON) $< $< erase "/pm_jobs" another_pmjob
# update ccn
	@$(EDIT_JSON) $< $< replace "/ccn/ipAddress" "\"$(FIXME)\""
	@$(EDIT_JSON) $< $< replace "/ccn/sftp user" "\"$(FIXME)\""
	@$(EDIT_JSON) $< $< replace "/ccn/sftp private key" "\"$(EMPTY)\""
	@$(EDIT_JSON) $< $< replace "/ccn/sftp port" "\"$(EMPTY)\""
	@$(EDIT_JSON) $< $< replace "/ccn/sftpExtraOptions" "\"-oStrictHostKeyChecking=no -oUserKnownHostsFile=/dev/null\""
	@$(EDIT_JSON) $< $< replace "/ccn/reports/incidents" "\"/incidents\""
	@$(EDIT_JSON) $< $< replace "/ccn/reports/statistics" "\"/stats\""
	@$(EDIT_JSON) $< $< replace "/ccn/reports/incidents_a" "\"/incidents_a\""
	@$(EDIT_JSON) $< $< replace "/ccn/digests/numbers" "\"/numbers\""
	@$(EDIT_JSON) $< $< replace "/ccn/digests/nodes" "\"/nodes\""
	@$(EDIT_JSON) $< $< replace "/ccn/digests/operators" "\"/operators\""
	@$(EDIT_JSON) $< $< replace "/ccn/digests/pub" "\"/pub\""
	@$(EDIT_JSON) $< $< replace "/ccn/connections/requests" "\"/connections/requests\""
	@$(EDIT_JSON) $< $< replace "/ccn/connections/responses" "\"/connections/responses\""
# update ccngw paths
	@$(EDIT_JSON) $< $< replace "/ccngw/digests/numbers" "\"$(FIXME)\""
	@$(EDIT_JSON) $< $< replace "/ccngw/digests/nodes" "\"$(FIXME)\""
	@$(EDIT_JSON) $< $< replace "/ccngw/digests/operators" "\"$(FIXME)\""
	@$(EDIT_JSON) $< $< replace "/ccngw/digests/pub" "\"$(FIXME)\""
	@$(EDIT_JSON) $< $< replace "/ccngw/connections/requests" "\"$(FIXME)\""
	@$(EDIT_JSON) $< $< replace "/ccngw/connections/responses" "\"$(FIXME)\""
	@$(EDIT_JSON) $< $< replace "/ccngw/reports/incidents" "\"$(FIXME)\""
	@$(EDIT_JSON) $< $< replace "/ccngw/reports/incidents_a" "\"$(FIXME)\""
	@$(EDIT_JSON) $< $< replace "/ccngw/reports/statistics" "\"$(FIXME)\""
# update sip parameters
	@$(EDIT_JSON) $< $< replace "/sip/incomingCallsPort" "\"5062\""
	@$(EDIT_JSON) $< $< replace "/sip/outgoingCallsPort" "\"5063\""
# adjust timers
	@$(EDIT_JSON) $< $< replace "/timers/getIncidentReq/period/value" 900
	@$(EDIT_JSON) $< $< replace "/timers/getIncidentReq/period/unit" "\"sec\""
	@$(EDIT_JSON) $< $< replace "/timers/getIncidentAReq/period/value" 900
	@$(EDIT_JSON) $< $< replace "/timers/getIncidentAReq/period/unit" "\"sec\""
	@$(EDIT_JSON) $< $< replace "/timers/refreshNumbersInfo/period/value" 4
	@$(EDIT_JSON) $< $< replace "/timers/refreshNumbersInfo/period/unit" "\"hr\""
	@$(EDIT_JSON) $< $< replace "/timers/refreshNodesInfo/period/value" 24
	@$(EDIT_JSON) $< $< replace "/timers/refreshNodesInfo/period/unit" "\"hr\""
	@$(EDIT_JSON) $< $< replace "/timers/refreshOperatorsInfo/period/value" 24
	@$(EDIT_JSON) $< $< replace "/timers/refreshOperatorsInfo/period/unit" "\"hr\""
	@$(EDIT_JSON) $< $< replace "/timers/refreshPublicKeys/period/value" 24
	@$(EDIT_JSON) $< $< replace "/timers/refreshPublicKeys/period/unit" "\"hr\""
	@$(EDIT_JSON) $< $< replace "/timers/refreshCallInfoRequests/period/value" 1
	@$(EDIT_JSON) $< $< replace "/timers/refreshCallInfoRequests/period/unit" "\"hr\""
	@$(EDIT_JSON) $< $< replace "/timers/resendReports/period/value" 1
	@$(EDIT_JSON) $< $< replace "/timers/resendReports/period/unit" "\"hr\""
	@$(EDIT_JSON) $< $< replace "/pm_jobs/call_statistics/period/value" 900
	@$(EDIT_JSON) $< $< replace "/pm_jobs/call_statistics/period/unit" "\"sec\""
# Update "call registry/TTL"
	@$(EDIT_JSON) $< $< replace "/vfs/call registry/TTL/period/value" 60
	@$(EDIT_JSON) $< $< replace "/vfs/call registry/TTL/period/unit" "\"sec\""
	@$(EDIT_JSON) $< $< replace "/vfs/call registry/searchTimeout/period/value" 400
ifneq (,$(wildcard $(CONFIG_FILE)))
	@echo "************************************"
	@echo "WARNING: $(CONFIG_FILE) already exists in the install directory, it will be renamed to $(CONFIG_OLD_FILE)."
	@echo "************************************"
	@mv $(CONFIG_FILE) $(CONFIG_OLD_FILE)
endif
	@mv $(CONFIG_TMP_FILE) $(CONFIG_FILE)
