REPO_AFAP_LIBS := libapigwnode.a libccngwnode.a libcligwnode.a liboamnode.a libvfcnode.a libvfsnode.a libvfgwnode.a
REPO_AFAP_LIBS += libasn1.a libconfig.a libdb_client.a libdb_mimic.a libfs.a libhasher.a libhttp.a libnumbers.a libseq.a libsftp.a libtimers.a libtools.a libtypes.a libworkernode.a 
REPO_AFAP_LIBS += libpmcommon.a libpmmanager.a libpmprovider.a libtestsupport.a
.PHONY: $(REPO_AFAP_LIBS)

REPO_AFAP_LIBS += libUvr.a

$(REPO_AFAP_LIBS): MAKE_OPTIONS := -C$(REPO_AFAP) -I$(BUILD_SUPPORT) product=

libapigwnode.a:
	$(MAKE) $(MAKE_OPTIONS) target2=apigw $@
libccngwnode.a:
	$(MAKE) $(MAKE_OPTIONS) target2=ccngw $@
libcligwnode.a:
	$(MAKE) $(MAKE_OPTIONS) target2=cligw $@
liboamnode.a:
	$(MAKE) $(MAKE_OPTIONS) target2=oam $@
libvfcnode.a:
	$(MAKE) $(MAKE_OPTIONS) target2=vfc $@
libvfsnode.a:
	$(MAKE) $(MAKE_OPTIONS) target2=vfs $@
libvfgwnode.a:
	$(MAKE) $(MAKE_OPTIONS) target2=vfgw $@

libasn1.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=asn1 $@
libconfig.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=config $@
libdb_client.a libdb_mimic.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=db $@
libfs.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=filesystem $@
libhasher.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=hasher $@
libhttp.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=http $@
libnumbers.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=numbers $@
libseq.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=sequencer $@
libsftp.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=sftp $@
libtimers.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=timers $@
libtools.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=tools $@
libtypes.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=types $@
libworkernode.a:
	$(MAKE) $(MAKE_OPTIONS) target2=components target3=worker_node $@


libpmcommon.a:
	$(MAKE) $(MAKE_OPTIONS) target2=pm target3=common $@
libpmmanager.a:
	$(MAKE) $(MAKE_OPTIONS) target2=pm target3=manager $@
libpmprovider.a:
	$(MAKE) $(MAKE_OPTIONS) target2=pm target3=provider $@

libtestsupport.a:
	$(MAKE) $(MAKE_OPTIONS) target2=test target3=support $@

ifeq ($(LIBUVR_PATH), )
  ifneq ($(CURDIR),$(REPO_AFAP)/release/kvr/src)
libUvr.a:
	$(MAKE) $(MAKE_OPTIONS) target2=release target3=kvr $@
  endif
endif
