## [3.0.2]() - 2023-11-23
- УВр-SIP вынесен в отдельный репозиторий.
- Изменена структура файлов/папок при установке продукта.

## [3.0.1]() - 2023-11-13
- Поддержка CSV старых форматов (с меньшим числом колонок).

## [3.0]() - 2023-11-10
- Поддержка протокола ЦСУ-УВР v.18.17.
- Добавлена обработка полей "ID_SRC" и "META_INFO" для справочника УВр.
- Изменён ответ на запрос о соединении: удалены поля "END_CODE" и "T_REASON_CODE", добавлено поле "RELEASE_CODE".
- Добавлена обработка поля "DURATION" для запросов о соединении.
- Добавлена обработка вызова с номером вызывающего абонента, принадлежащего узлу верификации со служебным идентификатором 16001.
- Добавлена обработка вызова с номером вызывающего абонента, принадлежащего узлу верификации со служебным идентификатором 16002, 16003. Такие вызовы не учитываются в статистике, инцидентах и не формируют запись в БД.
- Неотправленные отчёты с информацией о соединениях перемещаются в соответствующую директорию. С определённой периодичностью отчеты отправляются повторно.
- Добавлен параметр конфигурационного файла, описывающий номер версии конфигурационного файла.
- Добавлена проверка конфигурационного файла. Проверка не пройдена, если:
  - номер версии в конфигурационном файле отсутствует или если номер присутствует, но не поддерживается;
  - невозможно прочитать хотя бы один из обязательных параметров из конфигурационного файла.
- Изменен вывод ответа на запрос о соединении при RSP_CODE != 1:
  - поле DATE_ACT заполняется значением равным полю DATE из запроса,
  - поле ID_REL заполняется пустым значением,
  - опциональные поля, которые не могут быть взяты из запроса - пустое значение.
- Добавлена обработка политик "MAINT" и "DEF_POLICY" в "META_INFO" для УВр.
- Изменены пути в конфигурационном файле:
  - `"ccngw"/"database"/"connections"` на `"ccngw"/"connections"`;
  - `"ccn"/"database"/"connections"` на `"ccn"/"connections"`;
  - `"ccngw"/"database"` на `"ccngw"/"digests"`;
  - `"ccn"/"database"` на `"ccn"/"digests"`.
- Добавлена обработка вызова с номером вызывающего абонента, принадлежащего узлу верификации со служебным идентификатором 16002, 16003.
- Изменения в основном API:
  - Удалено:
    - `Uvr::EndCode_t`, `Uvr::OptionalEndCode`.
    - `Uvr::TransitReasonCode_t`.
    - `Uvr::OptionalCallId`.
    - `Uvr::OptionalNumber`.
  - Изменено:
    - Значения кодов для `Uvr::VerificationVerdict` и `Uvr::VerificationResponse`.
    - В функции обратного вызова `CallInformationRequestCallback`, `StoreRecordCallback`, `UpdateRecordsCallback` добавлен параметр `uvrId`.
    - Структура `Uvr::Record` переименована в `Uvr::CallRecord`.
    - В методе `Uvr::API::notifyAboutOutgoingCall()` добавлен опциональный аргумент `idDst`.
  - Добавлено:
    - `Uvr::MetaInfo::BitFlags_t` и `Uvr::MetaInfo::String`.
    - `Uvr::ReleaseCode_t`, `Uvr::OptionalReleaseCode`.
    - `Uvr::OptionalTransitActionCode`.
    - `Uvr::OptionalUvrId`.
    - `Uvr::OptionalVerificationRsp`.
    - `Uvr::CallType_t`.
    - Новый код ответа `Uvr::ResponseCode::systemError`.
  - Структура `Uvr::CallInformationResponse`:
    - Удалены поля:
      - `Uvr::EndCode_t endCode`.
      - `Uvr::TransitReasonCode_t tReasonCode`.
    - Изменены типы полей:
      - `OperatorId_t idSrc` на `OptionalOperatorId idSrc`.
      - `OperatorId_t idDst` на `OptionalOperatorId idDst`.
      - `VerificationResponse_t vrfRsp` на `OptionalVerificationRsp vrfRsp`.
      - `TransitActionCode_t tActionCode` на `OptionalTransitActionCode tActionCode`.
      - `UvrId_t idUvrT` на `OptionalUvrId idUvrT`.
    - Добавлены поля:
      - `Uvr::OptionalReleaseCode releaseCode`
      - `Uvr::VerdictTrigger_t idRel`.
  - Структура `Uvr::CallInformationRequest`:
    - Изменены типы полей:
      - `OptionalNumber numC` на `Number numC`.
      - `OptionalNumber numD` на `Number numD`.
      - `OptionalCallId idCall` на `CallId_t callId`.
    - Добавлены поля:
      - `OptionalCallDuration callDuration`.
  - Структура `Uvr::UvrInfo`:
    - Добавлены типы и методы для работы с Meta Info.
    - Добавлены поля:
      - `OperatorId_t idSrc`.
      - `MetaInfo::BitFlags_t metaInfo`.
  - Структура `Uvr::Record`:
    - Добавлено поле `callType`.
- Добавлена секция `/vfs/call registry` в конфигурационном файле. Параметр конфигурации `/vfs/call registry TTL` перенесен в `/vfs/call registry/TTL`
- Добавлен параметр `/vfs/call registry/searchTimeout`
- Добавлен параметр `/ccn/sftpExtraOptions`
- На старте при отсутствии связи с ЦСУ будут загружаться данные из локальных справочников, даже если время их жизни больше периода обновления справочника.

## [2.6]() - 2023-10-19
- Исправлена опечатка в prerequisites.sh
- Включена оптимизация компилятора для некоторых компонент для ускорения процесса загрузки справочника нумерации.
- В конфигурационном файле убраны значения по-умолчанию в секции `/"ccngw"`.
- Исправлено формирование метки начала отсчетного периода для файлов статистики.
- Улучшено логирование ошибок при верификации вызова.
- Исправлено определение актуальности локальных справочников нумерации.
- Описан интерфейс командной строки (CLI).
- Описано дополнительное программное обеспечение.
- Исправлено форматирование некоторых полей файла с ответом на запрос данных о соединении.

## [2.5]() - 2023-10-02
- Добавлена обработка нового ключа ("MAINT") в Meta Info.
- Отчёты, которые не удалось отправить, теперь перемещаются в соответствующую директорию. С определённой периодичностью они отправляются повторно.
- Уменьшено количество сигналов ОС перехватываемых КВр, обрабатывается только SIGUSR1.
- Добавлен новый параметр в конфигурационном файле: `/"timers"/"resendReports"`.
- Добавлена возможность конфигурации директорий, в которых будут генерироваться отчёты перед отправкой в ЦСУ. `/"ccngw"/"reports"/"incidents"`, `/"ccngw"/"reports"/"incidents_a"`, `/"ccngw"/"reports"/"statistics"`.
- Добавлены новые конфигурационные параметры для подключения к SFTP серверу на ЦСУ: `/"ccn"/"sftp private key"`, `/"ccn"/"sftp port"`.
- Записи из реестра исходящих соединений удаляются только по истечение времени жизни.
- Изменения в основном API:
  - Добавлены новые методы регистрации функций обратного вызова `Uvr::API::registerStoreRecordCallback` и `Uvr::API::registerUpdateRecordsCallback`.
  - В метод `Uvr::API::notifyAboutOutgoingCall` добавлен опциональный аргумент `const Uvr::CallId_t &callId`.
  - В структуру `Uvr::VerificationResult` добавлено поле `CallId_t callId`.

## [2.4]() - 2023-08-28
- Добавлено конфигурирование длительности хранения записи об исходящем вызове через конфигурационный параметр "/vfs/call registry TTL".
- Добавлена обработка пустого номера А (звонящий номер).
- Номера превышающие допустимую длину (хешированный номер - 10 байт, не хешированный - 8 байт) теперь обрезаются.
- Исправление проблемы закрытия HTTP соединения в сторону УВЗ через 50 мс.
- Добавлена поддержка загрузки справочника операторов с ЦСУ.
- Поддержка протокола ЦСУ-УВР v.18.8.
- Поддержка протокола УВр-УВр IP v.10.6.
- Изменения в основном API:
  - В методе `Uvr::API::notifyAboutOutgoingCall()` удалён аргумент `idDst`.
  - В "`namespace Uvr::API::Digest`" добавлен метод для получения информации из справочника операторов.
  - В "`namespace Uvr::VerificationResponse`" добавлены новые значения.
  - Добавлен "`namespace Uvr::VerificationVerdict`".
  - `Uvr::VerificationResult` теперь использует значения из "`namespace Uvr::VerificationVerdict`" вместо "`namespace Uvr::VerificationResponse`".
- Исправление мелких ошибок.

## [2.3]() - 2023-07-20
- Улучшена проверка вызовов на собственную нумерацию УВр.
- Изменения в основном API:
  - Библиотека компонента верификации переименована из libvfn.a в libUvr.a.
  - Все типы, которые используются для взаимодействия с компонентом верификации, перенесены в UvrTypes.hpp и сгруппированы в "`namespace Uvr`". api_types.hpp и user_api_types.hpp удалены.
  - Все методы, которые используются для взаимодействия с компонентом верификации, перенесены в UvrAPI.hpp и сгруппированы в "`namespace Uvr::API`". user_api.hpp и vfn_api.hpp удалены.
  - В "`namespace Uvr::API::Digest`" добавлены методы для получения различной информации из справочников.
- Исправление мелких ошибок, повышение стабильности.

## [2.2.1]() - 2023-07-07
- Критическое исправление интерфейса верификации.

## [2.2]() - 2023-07-04
- Поддержка протокола ЦСУ-УВр v.18.2 включая incidents_a.
- Обеспечение обязательности хэширования NUM_B/NUM_C в сообщениях верификации и выгрузках инцидентов.
- Повышение стабильности.

## [2.1]() - 2023-06-20
- Поддержка протокола ЦСУ-УВр v.18.2 за исключением incidents_a.
- Uplift Boost 1.82.0.
- Uplift C++17.
- Исправление мелких ошибок, повышение стабильности.

## [2.0]() - 2023-04-20
- Первая версия.
