#pragma once

/// Contains paths in config file and default values for the corresponding parameters.
namespace Config
{
    namespace DB
    {
        /// Parameters for ClickHouse DB client
        namespace ClckH
        {
            /// The host of ClickHouse server
            constexpr auto Host = "/storage/clckh/host";
            constexpr auto DefaultHost = "localhost";

            /// The port of ClickHouse server
            constexpr auto Port = "/storage/clckh/port";
            constexpr auto DefaultPort = "9000";

            /// The ClickHouse database name
            constexpr auto Database = "/storage/clckh/database";
            constexpr auto DefaultDatabase = "default";

            /// The ClickHouse user name
            constexpr auto User = "/storage/clckh/user";
            constexpr auto DefaultUser = "default";

            /// The ClickHouse password
            constexpr auto Password = "/storage/clckh/password";

            /// Buffer of insert records:
            /// Buffer size
            constexpr auto InsertBufferSize = "/storage/clckh/insert buffer/size";
            constexpr auto DefaultInsertBufferSize = 1000;
            /// Period for flushing records into DB
            constexpr auto InsertBufferFlushTimer = "/storage/clckh/insert buffer/flush timer/period";
            constexpr auto DefaultInsertBufferFlushTimer = boost::asio::chrono::milliseconds(500);

            /// Buffer of update records:
            /// Buffer size
            constexpr auto UpdateBufferSize = "/storage/clckh/update buffer/size";
            constexpr auto DefaultUpdateBufferSize = 100;
            /// Period for flushing records into DB
            constexpr auto UpdateBufferFlushTimer = "/storage/clckh/update buffer/flush timer/period";
            constexpr auto DefaultUpdateBufferFlushTimer = boost::asio::chrono::milliseconds(500);

        } // namespace ClckH
    } // namespace DB
} // namespace Config
