#pragma once

// Log includes.
#include "Logger.hpp"

// STL includes.
#include <iostream>

namespace Log
{
    class CoutLogger : public Logger
    {
    public:
        CoutLogger() = default;
        ~CoutLogger() override;

    private:
        void processMessage(std::string &&message) override;
    };
} // namespace Log

//------------------------------------------------------------------------------
// Definitions
//------------------------------------------------------------------------------

namespace Log
{
    inline CoutLogger::~CoutLogger()
    {
        std::cout << std::flush;
    }

    inline void CoutLogger::processMessage(std::string &&message)
    {
        std::cout << message + '\n';
    }
} // namespace Log
