#pragma once

// Log includes.
#include "LoggersGroup.hpp"
#include "CerrLogger.hpp"

namespace Log
{
    class GlobalLoggersGroup final : public LoggersGroup
    {
    public:
        static GlobalLoggersGroup & getInstance();

    public:
        /// @name Deleted methods
        /// @{

        GlobalLoggersGroup(const GlobalLoggersGroup &) = delete;
        void operator= (const GlobalLoggersGroup &) = delete;

        /// @}

    private:
        GlobalLoggersGroup();
        ~GlobalLoggersGroup() final = default;
    };
} // namespace Log

//------------------------------------------------------------------------------
// Definitions
//------------------------------------------------------------------------------

namespace Log
{
    inline GlobalLoggersGroup & GlobalLoggersGroup::getInstance()
    {
        static GlobalLoggersGroup instance;
        return instance;
    }

    inline GlobalLoggersGroup::GlobalLoggersGroup()
    {
        this->add(std::make_shared<CerrLogger>());
    }
} // namespace Log
