#pragma once

// STL includes.
#include <ios>

namespace Log
{
    class StreamFormatBackup final
    {
    public:
        StreamFormatBackup(std::ios &ios);
        ~StreamFormatBackup();

    public:
        /// @name Deleted methods
        /// @{

        StreamFormatBackup(const StreamFormatBackup &) = delete;
        void operator= (const StreamFormatBackup &) = delete;

        /// @}

    private:
        std::ios &m_ios;
        std::ios_base::fmtflags m_flags;
        char m_fill;
    };
} // namespace Log

//------------------------------------------------------------------------------
// Definitions
//------------------------------------------------------------------------------

namespace Log
{
    inline StreamFormatBackup::StreamFormatBackup(std::ios &ios)
        : m_ios(ios),
          m_flags(ios.flags()),
          m_fill(ios.fill())
    {
    }

    inline StreamFormatBackup::~StreamFormatBackup()
    {
        m_ios.flags(m_flags);
        m_ios.fill(m_fill);
    }
} // namespace Log
