#pragma once

// AFAP includes.
#include "components/timers/src/timer_object.hpp"

namespace timers
{
    class oneshot : public timer
    {
    public:
        oneshot(boost::asio::io_context &ioc,
                const std::string &name,
                timers::duration duration,
                const id &timerId = id()) : timer(ioc, name, duration, timerId)
        {
        }
        oneshot(const boost::asio::strand<boost::asio::io_context::executor_type> &strand,
                const std::string &name,
                timers::duration duration,
                const id &timerId = id()) : timer(strand, name, duration, timerId)
        {
        }
        ~oneshot() override = default;

        type getType() const override
        {
            return timers::type::ONESHOT;
        }

    protected:
        void handle_internal(void) final
        {
            interfaces::manager::client1::manage_stopped(m_timerId);
            interfaces::manager::client1::manage_timeout(m_timerId, m_startTime);
        }
    };
}
