#include "oam_pm_provider.hpp"

namespace oam
{
    namespace pm
    {
        provider::provider(std::shared_ptr<::pm::primitive::ProviderRegisterReq> prim) : m_inst(prim->m_header->from),
                                                                                         m_counters(prim->counters)
        {
        }

        std::shared_ptr<::pm::primitive::GetCountersReq>
        provider::buildGetCountersReq(std::shared_ptr<::pm::primitive::GetStatisticsReq> prim) const
        {
            auto req = std::make_shared<::pm::primitive::GetCountersReq>(prim->reset);

            req->m_header->to = m_inst;
            for (auto counterIter = prim->counters.begin(); counterIter != prim->counters.end(); counterIter++)
            {
                for (auto idIter : m_counters)
                {
                    if (idIter == counterIter->first)
                    {
                        req->counters.emplace_back(idIter, counterIter->second);
                        break;
                    }
                }
            }
            if (req->counters.empty())
            {
                req.reset();
            }
            return req;
        }
    }
}
