#pragma once

#include "worker_node/src/sender.hpp"
#include "common/src/pm_primitive.hpp"
#include "worker_node/src/transaction_manager.hpp"

namespace oam
{
    namespace pm
    {
        class provider
        {
        public:
            explicit provider(std::shared_ptr<::pm::primitive::ProviderRegisterReq> prim);
            std::shared_ptr<::pm::primitive::GetCountersReq>
            buildGetCountersReq(std::shared_ptr<::pm::primitive::GetStatisticsReq> prim) const;

        protected:
            // Type Instance of PM Provider node
            TypeInst m_inst;
            // The list of supported counters
            ::pm::counter::vectorIDs m_counters;
        };
    }
}
