#pragma once

// AFAP includes.
#include "pm/common/src/pm_types.hpp"

// STL includes.
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>

namespace configuration
{
    namespace counter
    {
        using entity = std::pair<std::string, std::string>;
        using list = std::vector<entity>;
    }
}

namespace pm
{
    namespace counter
    {
        using map_named = std::unordered_map<std::string, id>;
        using map_ids = std::unordered_map<id, std::string>;

        extern const map_named all_names;
        extern const map_ids all_ids;

        void list2fullIDs(configuration::counter::list in, vectorFullIDs &out);

        enum class indexing
        {
            no = 0,
            yes = 1
        };

    }
}

#include "gen_map.hpp"
