#pragma once

// Boost includes.
#include <boost/json.hpp>

// STL includes.
#include <vector>
#include <map>

#define NO_INDEX "no"
#define ALL_INDEX "all"
#define ANY_INDEX "any"

namespace pm
{
    namespace counter
    {
        class value;
        using id = uint32_t;
        using index = std::string;
        using full_id = std::pair<id, index>;
        using index_value = std::pair<index, value>;
        using id_value = std::pair<id, value>;
        using vectorIDs = std::vector<id>;
        using vectorFullIDs = std::vector<full_id>;
        using container = std::multimap<id, index_value>;
        using value_t = uint32_t;

        class value
        {
        public:
            value_t m_value;

            value();
            explicit value(value_t val);

            static value no_value();

            value &operator+=(const value &delta);
            value operator+(const value &delta) const;
            bool operator==(const value &v) const;
        };

        std::ostream &operator<<(std::ostream &os, const value &v);
        void tag_invoke(boost::json::value_from_tag, boost::json::value &jv, value const &v);
        value tag_invoke(boost::json::value_to_tag<value>, boost::json::value const &jv);
    }

    enum class errors
    {
        OK,
        FAIL
    };

} // namespace pm
