#pragma once

// AFAP includes.
#include "components/support/interfaces_template.hpp"
#include "components/worker_node/src/primitive.hpp"
#include "pm/common/src/counters_map.hpp"

namespace pm
{
    namespace interfaces
    {
        INTERFACE_S(provider,
                    INTERFACE_SERVER(void, registerCounters);
                    INTERFACE_SERVER(void, addCounter, counter::id, counter::indexing);
                    INTERFACE_SERVER(void, addCounter, counter::id, counter::index);
                    INTERFACE_SERVER(void, increaseCounter, counter::id, counter::value);
                    INTERFACE_SERVER(void, increaseCounter, counter::id, counter::index, counter::value);
                    INTERFACE_SERVER(void, resetCounterNoIndex, counter::id);
                    INTERFACE_SERVER(void, resetCounter, counter::id, const counter::index &);
                    INTERFACE_SERVER(void, setCounter, counter::id, counter::value);
                    INTERFACE_SERVER(void, setCounter, counter::id, counter::index, counter::value);
                    INTERFACE_SERVER(void, handleGetCountersReq, const ::primitive::GenericPtr &);)

        INTERFACE_C(provider,
                    INTERFACE_CLIENT(void, registerCounters);
                    INTERFACE_CLIENT(void, addCounter, counter::id, counter::indexing);
                    INTERFACE_CLIENT(void, addCounter, counter::id, counter::index);
                    INTERFACE_CLIENT(void, increaseCounter, counter::id, counter::value);
                    INTERFACE_CLIENT(void, increaseCounter, counter::id, counter::index, counter::value);
                    INTERFACE_CLIENT(void, resetCounterNoIndex, counter::id);
                    INTERFACE_CLIENT(void, resetCounter, counter::id, const counter::index &);
                    INTERFACE_CLIENT(void, setCounter, counter::id, counter::value);
                    INTERFACE_CLIENT(void, setCounter, counter::id, counter::index, counter::value);
                    INTERFACE_CLIENT(void, handleGetCountersReq, const ::primitive::GenericPtr &);)
    } // interfaces
} // pm
