#include "pm/provider/src/pm_node.hpp"

namespace pm
{
    node::node(const TypeInst &ownInst,
               boost::asio::io_context &ioc,
               const configuration::manager &config)
        : workers::node(ownInst, ioc, config)
    {
        this->::workers::interfaces::sender::client::bind(this);
    }

    void node::start(void)
    {
        workers::node::start();
        prepareCounters();
        registerCounters();
    }

    void node::handleSpecificPrimitive(const ::primitive::GenericPtr &prim)
    {
        switch (prim->m_header->id)
        {
        case ::primitive::GET_COUNTERS_REQ:
        {
            handleGetCountersReq(prim);
            break;
        }
        default:
            workers::node::handleSpecificPrimitive(prim);
        }
    }

} // namespace pm
