#pragma once

// AFAP includes.
#include "components/worker_node/src/node.hpp"
#include "pm/provider/src/pm_provider.hpp"

namespace pm
{
    class node : public workers::node,
                 public provider
    {
    public:
        void start(void) override;

    protected:
        explicit node(const TypeInst &ownInst,
                      boost::asio::io_context &ioc,
                      const configuration::manager &config);

        void handleSpecificPrimitive(const ::primitive::GenericPtr &prim) override;

        /// @brief Adds the counters, which are handled by PM Node.
        /// @note Should be overriden for specific counters of derived node.
        virtual void prepareCounters() = 0;
    };

} // namespace pm
