#pragma once

// AFAP includes.
#include "components/config/src/config_manager.hpp"
#include "components/worker_node/src/primitive.hpp"

// OpenSSL includes.
#include <openssl/rsa.h>

namespace Crypto
{
    class Rsa
    {
    public:
        Rsa(const configuration::manager &config);
        virtual ~Rsa();

        bool encrypt(RSA *key,
                     const ::primitive::raw_data_t &inData,
                     ::primitive::raw_data_t &outData);
        bool decrypt(const ::primitive::raw_data_t &inData,
                     ::primitive::raw_data_t &outData);

        bool signRecover(RSA *key,
                         const ::primitive::raw_data_t &signature,
                         ::primitive::raw_data_t &digest);

        RSA *readPublicKey(const std::string &pubKeyFile);
        RSA *readPrivateKey(const std::string &privKeyFile);

    private:
        RSA *m_ownPrivateKey{nullptr};
    };

} // namespace Crypto
