#pragma once

#include "components/worker_node/src/primitive.hpp"
#include "vfgw/src/http_message.hpp"

namespace http
{
    struct VerifyCallData
    {
        Uvr::OperatorId_t m_idSrc;
        Uvr::UvrId_t m_idUvrS;
        bool m_usedUvrS{false};
        ::primitive::SessionKey_t m_sessionKey;
        std::string m_sessionId;
        std::string m_reqData;

        VerifyCallData(Uvr::OperatorId_t idSrc,
                       Uvr::UvrId_t idUvrS = 0,
                       ::primitive::SessionKey_t sessionKey = 0,
                       const std::string &sessionId = "",
                       const std::string &reqData = "")
            : m_idSrc(idSrc),
              m_idUvrS(idUvrS),
              m_sessionKey(sessionKey),
              m_sessionId(sessionId),
              m_reqData(reqData)
        {
        }
    };

} // http
