#pragma once

#include "headers.hpp"
#include "header_content_type.hpp"

#include <list>
#include <string>

namespace sip
{

    class Body
    {
    public:
        int doParse(std::string &&buf);
        std::string toStr(int &errorCode);

        int doParseMime(const char *startOfBody, size_t length);

    protected:
        int doParseHeader(const char *startOfBodyHeader,
                          const char **next_body);
        int setContentType(const char *hvalue);
        int setHeader(std::string &&hname,
                      std::string &&hvalue);

    public:
        std::string m_body;                   ///< buffer containing data
        header::GenericPtrList m_headers;     ///< List of headers (when mime is used)
        header::ContentTypePtr m_contentType; ///< Content-Type (when mime is used)
    };
    using BodyPtr = std::shared_ptr<Body>;
    using BodyList = std::list<BodyPtr>;

} // namespace sip
