#pragma once

// STL includes.
#include <list>
#include <string>

namespace sip
{

    constexpr int SUCCESS = 0;
    constexpr int UNDEFINED_ERROR = -1;
    constexpr int BADPARAMETER = -2;
    constexpr int SYNTAXERROR = -5;

    struct GenericParam
    {
        std::string m_name;  ///< parameter name
        std::string m_value; ///< parameter value

        GenericParam(std::string &&pname, std::string &&pvalue);
    };

    class GenericParamList : public std::list<GenericParam>
    {
    public:
        GenericParam *match(const std::string &name,
                            int &errorCode);

        int doParse(const char *params);
    };

} // namespace sip
