#include "header_allow.hpp"

namespace sip::header
{

    Allow::Allow()
        : Abstract(std::string("Allow"))
    {
    }

    int Allow::doParse(std::string &&hvalue)
    {
        if (hvalue.empty())
        {
            return BADPARAMETER;
        }

        if (hvalue.length() + 1 < 2)
        {
            return SYNTAXERROR;
        }

        m_value = std::move(hvalue);

        return SUCCESS;
    }

    int Allow::doParse(const char *hvalue)
    {
        return UNDEFINED_ERROR;
    }

    std::string Allow::valueToStr(int &errorCode)
    {
        errorCode = SUCCESS;
        return m_value;
    }

} // namespace sip::header
