#include "header_callid.hpp"

namespace sip::header
{

    CallId::CallId()
        : Abstract(std::string("Call-ID"))
    {
    }

    int CallId::doParse(const char *hvalue)
    {
        if (hvalue == nullptr)
        {
            return BADPARAMETER;
        }

        m_value = std::string(hvalue);
        return SUCCESS;
    }

    std::string CallId::valueToStr(int &errorCode)
    {
        RETURN_STR(SUCCESS, m_value);
    }

    std::string CallId::getValue()
    {
        return m_value;
    }


} // namespace sip::header
