#include "header_content_length.hpp"

namespace sip::header
{

    ContentLength::ContentLength()
        : Abstract(std::string("Content-Length"))
    {
    }

    int ContentLength::doParse(std::string &&hvalue)
    {
        if (hvalue.empty())
        {
            return BADPARAMETER;
        }

        if (hvalue.length() + 1 < 2)
        {
            return SYNTAXERROR;
        }

        m_value = std::move(hvalue);

        return SUCCESS;
    }

    int ContentLength::doParse(const char *hvalue)
    {
        return UNDEFINED_ERROR;
    }

    std::string ContentLength::valueToStr(int &errorCode)
    {
        errorCode = UNDEFINED_ERROR;
        return "";
    }

} // namespace sip::header
