#pragma once

#include "headers.hpp"

#include <memory>
#include <string>

namespace sip::header
{

    class ContentType : public Abstract
    {
    public:
        ContentType();
        std::string valueToStr(int &errorCode) override;
        int doParse(const char *hvalue) override;

        std::string m_type;                /**< Type of attachement */
        std::string m_subtype;             /**< Sub-Type of attachement */
        sip::GenericParamList m_genParams; /**< Content-Type parameters */
    };
    using ContentTypePtr = std::shared_ptr<ContentType>;

} // namespace sip::header
