#include "header_diversion.hpp"
#include "utils.hpp"

// STL includes.
#include <cstring>

namespace sip::header
{

    Diversion::Diversion()
        : Abstract(std::string("Diversion"))
    {
    }

    std::string Diversion::valueToStr(int &errorCode)
    {
        if (m_value.empty())
        {
            RETURN_STR_FAIL(BADPARAMETER);
        }

        std::string ret = m_value;

        RETURN_STR(SUCCESS, ret);
    }

    int Diversion::doParse(const char *hvalue)
    {

        if (hvalue == nullptr)
        {
            return BADPARAMETER;
        }

        m_value = utils::doCopyAndClearLws(hvalue,
                                           std::strlen(hvalue));

        return SUCCESS;
    }

} // namespace sip::header
