#pragma once

#include "headers.hpp"
#include "uri.hpp"

#include <memory>
#include <string>

namespace sip
{

    namespace header
    {

        class From : public Abstract
        {
        public:
            From();

            int doParse(const char *hvalue) override;
            std::string valueToStr(int &errorCode) override;

            std::string m_displayName;    ///< Display Name
            UriPtr m_uri;                 ///< uri
            GenericParamList m_genParams; ///< other parameters
        };

        using FromPtr = std::shared_ptr<From>;

        class To : public From
        {
        public:
            To() : From()
            {
                m_name = "To";
            }
        };
        using ToPtr = std::shared_ptr<To>;

    } // namespace header

} // namespace sip
