#pragma once

#include "headers.hpp"
#include "uri.hpp"

#include <memory>
#include <string>

namespace sip::header
{

    class Via : public Abstract
    {
    public:
        Via();

        int doParse(const char *hvalue) override;
        std::string valueToStr(int &errorCode) override;

        std::string m_version;     ///< SIP Version
        std::string m_protocol;    ///< Protocol used by SIP Agent
        std::string m_host;        ///< Host where to send answers
        std::string m_port;        ///< Port where to send answers
        std::string m_comment;     ///< Comments about SIP Agent
        GenericParamList m_params; ///< Via parameters
    };

    using ViaPtr = std::shared_ptr<Via>;

} // namespace sip::header
