#pragma once

// AFAP includes.
#include "components/sip/src/transports.hpp"
#include "components/worker_node/src/transaction_manager.hpp"

namespace modules
{

    namespace sip
    {

        namespace transaction
        {

            class data : public ::transaction::base_data
            {
            public:
                ::sip::trunk::Reference m_ref;
                ::sip::MessagePtr m_msg;

                Uvr::Number m_callingNumberStr;
                Uvr::Number m_calledNumberStr;
                Uvr::Number m_originalCalledNumberStr;
                Uvr::Number m_genericNumberStr;
                Uvr::OperatorId_t m_operatorId;
                Uvr::CallId_t m_callId;

                data() = default;
                data(const ::sip::trunk::Reference &sipConnId,
                     const ::sip::MessagePtr &sipMsg,
                     const Uvr::Number &callingNumberStr,
                     const Uvr::Number &calledNumberStr,
                     const Uvr::Number &originalCalledNumberStr,
                     const Uvr::Number &genericNumberStr,
                     const Uvr::OperatorId_t &operatorId,
                     const Uvr::CallId_t &callId)
                    : m_ref(sipConnId),
                      m_msg(sipMsg),
                      m_callingNumberStr(callingNumberStr),
                      m_calledNumberStr(calledNumberStr),
                      m_originalCalledNumberStr(originalCalledNumberStr),
                      m_genericNumberStr(genericNumberStr),
                      m_operatorId(operatorId),
                      m_callId(callId)

                {
                }
            };

        }

    } // namespace sip

} // namespace modules
