#pragma once

// Storage includes.
#include "modules/storage/src/StorageClient.hpp"

// AFAP includes.
#include "db/src/ClickHouse.hpp"
#include "components/tools/src/Tools.hpp"

namespace Storage
{
    class ClickHouseClient : public Client
    {
    public:
        ClickHouseClient(const Uvr::UvrId_t uvrId,
                         const configuration::manager &config);
        ~ClickHouseClient();

        bool connect() override;
        void disconnect() override;

        int getActualVersion() const override;
        int getExpectedVersion() const override;

        bool init() override;
        bool upgrade(const int actualVersion, const int expectedVersion) override;

        void storeVerdict(const Uvr::CallRecord &record) override;
        bool updateVerdict(const Uvr::CallRecord &record) override;

    protected:
        io_service::Context m_ioc;
        std::shared_ptr<db::ClickHouseAcc> m_dbClient; ///< Pointer to ClickHouse DB client
    };                                                 ///< class ClickHouseClient

} // namespace Storage
