#pragma once

//AFAP includes.
#include "config/src/config_manager.hpp"
#include "db/src/client.hpp"
#include "UvrTypes.hpp"

namespace Storage
{
    class Client : public db::interfaces::tables::client,
                   public db::interfaces::tables::calls::client
    {
    public:
        Client() = default;
        virtual ~Client() = default;

        virtual bool connect() = 0;
        virtual void disconnect() = 0;

        virtual int getActualVersion() const = 0;
        virtual int getExpectedVersion() const = 0;

        virtual bool init() = 0;
        virtual bool upgrade(const int actualVersion, const int expectedVersion) = 0;

        virtual void storeVerdict(const Uvr::CallRecord &record) = 0;
        virtual bool updateVerdict(const Uvr::CallRecord &record) = 0;
    }; // class Client

    using ClientUniquePtr = std::unique_ptr<Client>;

} // namespace Storage
