#!/bin/bash

CLCKH_CFG=/etc/clickhouse-server/config.xml
PARENT_DIR=$(dirname "$0")

cp ${PARENT_DIR}/clickhouse_config.xml ${CLCKH_CFG}
chown clickhouse:clickhouse ${CLCKH_CFG}

USER=uvr
PASSWD=$USER
DB=$USER
UVRID=$1

sed -i 's/<!-- <access_management>1<\/access_management> -->/<access_management>1<\/access_management>/' /etc/clickhouse-server/users.xml
clickhouse restart
clickhouse-client --query="CREATE USER '$USER' IDENTIFIED WITH plaintext_password BY '$PASSWD'"
clickhouse-client --query="GRANT CREATE TABLE ON *.* TO '$USER'"
clickhouse-client --query="GRANT DROP TABLE ON *.* TO '$USER'"
clickhouse-client --query="GRANT CREATE DATABASE ON *.* TO '$USER'"
clickhouse-client --query="GRANT DROP DATABASE ON *.* TO '$USER'"
clickhouse-client --query="GRANT SELECT ON *.* TO '$USER'"
clickhouse-client --query="GRANT INSERT ON *.* TO '$USER'"
clickhouse-client --query="GRANT ALTER UPDATE ON *.* TO '$USER'"
clickhouse-client --user=$USER --password=$PASSWD --query="create database \"${DB}_${UVRID}\""
sed -i 's/<access_management>1<\/access_management>/<!-- <access_management>1<\/access_management> -->/' /etc/clickhouse-server/users.xml
clickhouse restart